#!/bin/sh
# NB Please see the file: Reproducing Code and Methods.pdf
# included in the distribution for a description of the following commands
# 
# This script is an executable outline for how to reproduce the methods in the paper
# but almost certainly should not be directly run since the compute requirements
# are extensive, and depend on OpenPBS or similar software to schedule the many
# compute jobs

perl make_figure2_data.pl
perl runjobbers.pl RUNJOBS
pushd figure2_data
matlab figure2.m &
popd
perl make_table1b_data.pl
perl runjobbers.pl RUNJOBS
pushd figure2_data
matlab figure3and4.m &
popd
python make_stopping_data_simplified.py
python jobber.py SMPL-STOPPING.jobs &
pid=$!
sleep 10000000
kill -9 $pid
pushd results_stopping
matlab figure5.m &
popd
echo "** make sure you follow the instructions in the lincs subdirectory"
echo "** to process the ConnectivityMap data! see reproducing lincs analysis.[docx,pdf]"
python make_lincs_data.py
python jobber.py LINCS.jobs &
pid=$!
sleep 10000000
kill -9 $pid
pushd results_lincs
matlab figure6.m &
popd
echo "done."
