function [ blah ] = myhmap2(differences, mm)

% Copyright (C) 2013,2014 Murphy Lab
% Lane Center for Computational Biology
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

imagesc(differences');
set(gca,'YDir','normal')
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [0 0 5 5]);

hColorBar = colorbar;
axis square;
caxis([-mm mm]);
hXLabel = xlabel('Responsive');
hYLabel = ylabel('Unique');
set( gca                       , ...
    'FontName'   , 'Arial' );
set([hXLabel, hYLabel, hColorBar], ...
    'FontName'   , 'Arial', ...
    'FontSize'   , 6);
set([hXLabel, hYLabel], ...
    'FontWeight' , 'bold'      );
set(gca, ...
  'Box'         , 'off'     , ...
  'TickDir'     , 'out'     , ...
  'TickLength'  , [.02 .02] , ...
  'XColor'      , [.0 .0 .0], ...
  'YColor'      , [.0 .0 .0], ...
  'YTick'       , 2:2:20, ...
  'XTick'       , 2:2:20, ...
  'XTickLabel',{'10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%'}, ...
  'YTickLabel',{'10%', '20%', '30%', '40%', '50%', '60%', '70%', '80%', '90%', '100%'}, ...
  'XMinorTick'  , 'on', ...
  'YMinorTick'  , 'on', ...
  'FontSize', 6, ...
  'LineWidth'   , 1         );
%set(gcf, 'PaperPositionMode', 'auto');
%cpos = get(hColorBar, 'Position');
%cpos(1) = cpos(1) + 0.05;
%cpos(3) = cpos(3)/2;
%set(hColorBar,'Position',cpos);
end

