function theAxis = scurve(results, points, presp, puniq)

% Copyright (C) 2013,2014 Murphy Lab
% Lane Center for Computational Biology
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

place = find((points(:,1)==presp) & (points(:,2)==puniq));

%here = results{1}{place};
%plot(1:100, here.active.performance./10000, 'r-', 'LineWidth', 2);hold on;
%plot(1:100, here.random.performance./10000, 'r:', 'LineWidth', 2);hold on;
here = results{2}{place};
plot(1:100, here.active.performance./10000, 'b-', 'LineWidth', 2);hold on;
plot(1:100, here.random.performance./10000, 'b:', 'LineWidth', 2);hold on;
here = results{3}{place};
plot(1:100, here.active.performance./10000, 'g-', 'LineWidth', 2);hold on;
plot(1:100, here.random.performance./10000, 'g:', 'LineWidth', 2);hold on;
hold off;
axis([0 101 0 1]);
hXLabel = xlabel('Batch');
hYLabel = ylabel('Accuracy');
set(gcf, 'PaperUnits', 'centimeters');
set(gcf, 'PaperPosition', [0 0 6.5 6.5]);
set([hXLabel, hYLabel], ...
    'FontName'   , 'Helvetica', ...
    'FontSize'   , 6);
set([hXLabel, hYLabel], ...
    'FontWeight' , 'bold'      );
set(gca, ...
  'Box'         , 'off'     , ...
  'TickDir'     , 'out'     , ...
  'TickLength'  , [.02 .02] , ...
  'XColor'      , [.0 .0 .0], ...
  'YColor'      , [.0 .0 .0], ...
  'YMinorTick'  , 'on', ...
  'XMinorTick'  , 'on', ...
  'FontSize', 6, ...
  'LineWidth'   , 1         );
zname = sprintf('%g responsive, %g unique',presp, puniq);

zzname = sprintf('_%g_responsive_%g_unique.tiff', presp, puniq);
%title(['Learning Curves: Active(solid) Random(dashed) sm(r) m(b) bc(k) ' zname]);
print(gcf, '-dtiff', ['031011_' zzname], '-r300');