import cmap.io.gct as gct
import string
import numpy
GCTObject = gct.GCT('qnorm_n855034x22268.gctx')

# col_inds = GCTObject.get_gctx_cid_inds('qnorm_n855034x22268.gctx')
# row_inds = GCTObject.get_gctx_rid_inds('qnorm_n855034x22268.gctx')
# GCTObject._open_gctx('qnorm_n855034x22268.gctx')
# rawmatrix = numpy.memmap('rawdata.npy', dtype=numpy.float, mode='w+', shape=(1000,len(col_inds)))


GCTObject.read(row_inds=range(10))

#CPC005_VCAP_34H_X2_B3_DUO52Hi53LO:I6
#Plate name_cell line_time point (I meant 24H) _ number of replicate_ bead set batch_ read mode (you don't need to care about this): well name

colnames = GCTObject.get_cids()

plate_and_well_to_drug = {}
fun = open('Broad LINCS Compound Perturbagens by plate.csv','r')
next(fun)
for rline in fun:
    Line = string.split(rline.rstrip(), ',')
    plate_and_well_to_drug[Line[0], Line[1]] = Line[2]


treatments = {}
cells = {}
sub_experiments = {}
for i,x in enumerate(colnames):
    Line = string.split(x, '_')
    if (Line[0], Line[5][-3:]) in plate_and_well_to_drug:
        drug_time = plate_and_well_to_drug[Line[0], Line[5][-3:]], Line[2]
        celline = Line[1]
        if drug_time not in treatments:
            treatments[drug_time] = []
        treatments[drug_time].append(i)
        if celline not in cells:
            cells[celline] = []
        cells[celline].append(i)
        if (drug_time, celline) not in sub_experiments:
            sub_experiments[drug_time, celline] = []
        sub_experiments[drug_time, celline].append(i)

# make sure we have a complete matrix
dds, ccs = zip(*sub_experiments.keys())
dds = set(dds)
ccs = list(set(ccs))
#len(dds)*len(ccs)

# no line is present for all treatments
# oklines = []
# for c in ccs:
#     if all([(d,c) in sub_experiments for d in dds]):
#         oklines.append(c)

okdrugs = []
for d in dds:
    if all([(d,c) in sub_experiments for c in ccs]):
        okdrugs.append(d)

kosher_experiments = {}
for d in okdrugs:
    for c in ccs:
        kosher_experiments[d,c] = sub_experiments[d,c]

kosher_column_ordering = []
kosher_key_ordering = []
fout = open('kosher_redone.csv','w')
for d in okdrugs:
    for c in ccs:
        kosher_key_ordering.append((d,c))
        x = d,c        
        y = kosher_experiments[x]
        fout.write(' '.join([x[0][0], x[0][1], x[1]]+[str(n) for n in y])+"\n")
        kosher_column_ordering.extend(y)

fout.close()
