import cmap.io.gct as gct
import string
import numpy

GCTObject = gct.GCT('qnorm_n855034x22268.gctx')
col_inds = GCTObject.get_gctx_cid_inds('qnorm_n855034x22268.gctx')
row_inds = GCTObject.get_gctx_rid_inds('qnorm_n855034x22268.gctx')
GCTObject._open_gctx('qnorm_n855034x22268.gctx')


fin = open('kosher_redone.csv','r')
kosher_column_ordering = []
kosher_buckets = []
treatments = {}
cells = {}
bi = 0
expts = {}
for rline in fin:
    Line = string.split(rline.rstrip())
    kosher_buckets.append([int(x) for x in Line[3:]])
    bidxn = range(bi,bi+len(kosher_buckets[-1]))
    bi += len(kosher_buckets[-1])
    expts[(Line[0], Line[2])] = kosher_buckets[-1]
    kosher_column_ordering.extend([int(x) for x in Line[3:]])
    if Line[0] not in treatments:
        treatments[Line[0]] = []
    treatments[Line[0]].extend(bidxn)
    if Line[2] not in cells:
        cells[Line[2]] = []
    cells[Line[2]].extend(bidxn)


rawdata = numpy.zeros((9946,22268))
bucket_cell_means = numpy.zeros((48,22268))
bucket_treatment_means = numpy.zeros((len(treatments),22268))

rawdata_std = numpy.load('rawdata_std_redone.npy')
rawdata_mean = numpy.load('rawdata_mean_redone.npy')


# now score the data
# ii = 0
# for c,idxn in cells.iteritems():
#     print ii
#     rawdata[:len(idxn),:] = GCTObject.matrix_node[numpy.sort(idxn),:]
#     rawdata[:len(idxn),:]-=rawdata_mean
#     rawdata[:len(idxn),:]/=rawdata_std
#     bucket_cell_means[ii,:] = numpy.mean(rawdata[:len(idxn),:],axis=0)
#     ii += 1

# numpy.save('bucket_cell_means_redone.npy', bucket_cell_means)

ii = 0
for t,idxn in treatments.iteritems():
    print ii
    rawdata[:len(idxn),:] = GCTObject.matrix_node[numpy.sort(idxn),:]
    rawdata[:len(idxn),:]-=rawdata_mean
    rawdata[:len(idxn),:]/=rawdata_std
    bucket_treatment_means[ii,:] = numpy.mean(rawdata[:len(idxn),:],axis=0)
    ii += 1

numpy.save('bucket_treatment_means_redone.npy', bucket_treatment_means)
