import cmap.io.gct as gct
import string
import numpy

GCTObject = gct.GCT('qnorm_n855034x22268.gctx')
col_inds = GCTObject.get_gctx_cid_inds('qnorm_n855034x22268.gctx')
row_inds = GCTObject.get_gctx_rid_inds('qnorm_n855034x22268.gctx')
GCTObject._open_gctx('qnorm_n855034x22268.gctx')


fin = open('kosher_redone.csv','r')
kosher_column_ordering = []
kosher_buckets = []
treatments = {}
cells = {}
bi = 0
expts = {}
for rline in fin:
    Line = string.split(rline.rstrip())
    kosher_buckets.append([int(x) for x in Line[3:]])
    bidxn = range(bi,bi+len(kosher_buckets[-1]))
    bi += len(kosher_buckets[-1])
    expts[(Line[0], Line[2])] = kosher_buckets[-1]
    kosher_column_ordering.extend([int(x) for x in Line[3:]])
    if Line[0] not in treatments:
        treatments[Line[0]] = []
    treatments[Line[0]].extend(bidxn)
    if Line[2] not in cells:
        cells[Line[2]] = []
    cells[Line[2]].extend(bidxn)


bucket_cell_means = numpy.load('bucket_cell_means_redone.npy')
bucket_treatment_means = numpy.load('bucket_treatment_means_redone.npy')

vbucket_cell_means = numpy.var(bucket_cell_means, axis=0)
vbucket_treatment_means = numpy.var(bucket_treatment_means,axis=0)
#genes_we_want_to_keep = numpy.where(vbucket_treatment_means > numpy.percentile(vbucket_treatment_means,99))[0]
genes_we_want_to_keep = numpy.argsort(vbucket_treatment_means)[::-1][:50]

final_matrix = numpy.zeros((len(treatments)*len(cells),len(genes_we_want_to_keep)))
afeat = numpy.zeros((22268,))

torder = treatments.keys()
corder = cells.keys()

fout_t = open('INTERMEDIATE-treatments.csv','w')
fout_c = open('INTERMEDIATE-celllines.csv','w')

enumerated_torder = enumerate(torder)
enumerated_corder = enumerate(corder)

for ti,t in enumerated_torder:
    fout_t.write(str(t)+"\n")

for ci,c in enumerated_corder:
    fout_c.write(str(c)+"\n")

fout_t.close()
fout_c.close()


ii = 0
for ti,t in enumerated_torder:
    print ti, len(torder)
    for ci,c in enumerated_corder:
        for col in expts[t,c]:
            afeat = GCTObject.matrix_node[col,:]
            final_matrix[ii,:] += afeat[genes_we_want_to_keep]
        final_matrix[ii,:] /= len(expts[t,c])
        ii += 1



final_matrix -= numpy.mean(final_matrix,axis=0)
final_matrix /= numpy.std(final_matrix,axis=0)

# zidx = numpy.zeros((len(torder),len(genes_we_want_to_keep)),dtype='i4')
# ii = 0
# for ti in range(len(torder)):
#     for g in range(len(genes_we_want_to_keep)):
#         zidx[ti,g] = ii
#         ii += 1


thedata = numpy.zeros((len(treatments)*len(genes_we_want_to_keep),len(cells)))
ii = 0
for ti,t in enumerate(torder):
    print ti, len(torder)
    for ci,c in enumerate(corder):
        for g in range(len(genes_we_want_to_keep)):
            thedata[g*len(torder)+ti,ci] = final_matrix[ii,g]
        ii += 1


# U,d,V = numpy.linalg.svd(thedata,full_matrices=False)
# pylab.plot(U[:,0], U[:,1],'k.'); pylab.show()

numpy.save('thedata.npy', thedata)
