#!/usr/bin/perl

$parent_dir = '022011_prime';
@parent_files = <$parent_dir/*>;
$num_drugs = 100;
$num_proteins = 100;

open RUNJOBS, ">", "RUNJOBS";

#my $num_unique_phenotypes = 8;

sub make_case {

  my $num_unique_phenotypes = $_[0];
  my $which_seed = $_[1];
  my $data_sample = $_[2];
  my $responsive = $_[3];
  my $replicated = $_[4];
  my $which_method = $_[5];
  my $which_learner =  $_[6];

  my $place = sprintf 'method_seed%u_pheno%u_sample%u_resp%u_uniq%u_mthd%u_learn%u', $which_seed, $num_unique_phenotypes, $data_sample, $responsive, $replicated, $which_method, $which_learner;
  system("mkdir ${place}");
  system("mkdir ${place}/results");
  foreach $file (@parent_files) {
    @f = split(/\//, $file);
    $fname = $f[$#f];
    system("ln -s /home/active/package/${parent_dir}/${fname} /home/active/package/${place}/${fname}");
  }
  # THISRUN
  open THERUN, "<", "/home/active/package/${place}/THE_FIGURE2_RUN.fl";
  open THISRUN, ">", "/home/active/package/${place}/THISRUN.fl";
  while ($line = <THERUN>) {
    $line =~ s/WHICH_METHOD/$which_method/; 
    $line =~ s/WHICH_LEARNER/$which_learner/; 
    $line =~ s/DATA_SAMPLE/$data_sample/; 
    $line =~ s/WHICH_SEED_TO_USE/$which_seed/;
    $line =~ s/NUM_DRUGS/$num_drugs/;
    $line =~ s/NUM_PROTEINS/$num_proteins/;
    $line =~ s/NUM_UNIQUE_PHENOTYPES/$num_unique_phenotypes/;
    $line =~ s/FRACTION_RESPONSIVE/$responsive/;
    $line =~ s/FRACTION_REPLICATED/$replicated/;
    print THISRUN $line;
  }
  open GENCASE, "<", "/home/active/package/${place}/generate_case.m";
  open THISCASE, ">", "/home/active/package/${place}/THISCASE.m";
  while ($line = <GENCASE>) {
    $fr = $responsive/100;
    $fp = $replicated/100;
	  
    $line =~ s/DATA_SAMPLE/$data_sample/g;
    $line =~ s/NUM_DRUGS/$num_drugs/g;
    $line =~ s/NUM_PROTEINS/$num_proteins/g;
    $line =~ s/NUM_UNIQUE_PHENOTYPES/$num_unique_phenotypes/g;
    $line =~ s/FRACTION_RESPONSIVE/$fr/g;
    $line =~ s/FRACTION_REPLICATED/$fp/g;
    print THISCASE $line;
  }
	
  $rjob = "/home/active/package/run__${place}.sh";
  open BFILE, "<", "blank__run.sh";
  open RUNFILE, ">", $rjob;
  while ($line = <BFILE>) {
    $line =~ s/RUNPLACE/$place/g;
    $line =~ s/PARENTPLACE/$parent_dir/g;
    print RUNFILE $line;
  }
  print RUNJOBS "JOB $rjob\n";
}

#&make_case(8,1,1,70,10);
#&make_case(8,1,1,90,25);
#&make_case(8,1,1,10,70);
#&make_case(8,1,1,25,90);

my $num_unique_phenotypes = 8;
my $responsive = 80;
my $replicated = 40;

for (my $which_seed = 1; $which_seed < 2; $which_seed++) {
  for (my $data_sample = 1; $data_sample < 4; $data_sample++) {
    for (my $which_method = 1; $which_method < 45; $which_method++ ) {
      for (my $which_learner = 1; $which_learner <= 2; $which_learner++ ) {
	&make_case($num_unique_phenotypes,$which_seed,$data_sample,$responsive,$replicated, $which_method, $which_learner);
      }
    }
  }
}
