import os
import string
import sys
import random

parent_dir = '/home/twoactive/for_sim_paper/20130328.for_l1000/'
rundir = '/home/twoactive/for_sim_paper/'
python_place = '/opt/python27/bin/python'
MY_results_location = '/home/twoactive/for_sim_paper/results_lincs/'
MY_logs_location = '/home/twoactive/for_sim_paper/logs_lincs/'

def make_case(results_location, which_seed_to_use, num_unique_phenotypes, batch_size):

    target_name = 'lincs_sd%u_ph%u_b%u' % (which_seed_to_use, num_unique_phenotypes, batch_size)
    fname = 'RUN-'+target_name+'.py'
    runfile = open(fname, 'w')
    runfile.write('#!'+python_place+"\n")
    runfile.write('#PBS -l walltime=48:20:00,mem=3000mb'+"\n")
    runfile.write('#PBS -m a'+"\n")
    runfile.write('#PBS -W umask=002'+"\n")

    runfile.write('import os'+"\n")
    runfile.write('import string'+"\n")
    runfile.write('import subprocess'+"\n")
    runfile.write('os.mkdir("'+rundir+target_name+'")'+"\n")
    runfile.write('os.chdir("'+rundir+target_name+'")'+"\n")
    runfile.write('xs = os.listdir("'+parent_dir+'")'+"\n")
    runfile.write('for x in xs:'+"\n")
    runfile.write("\t"+'os.symlink("'+parent_dir+'"+x, "'+rundir+target_name+'"+"/"+x)'+"\n")
    runfile.write('therun = open("THE_LINCS_RUN.fl", "r")'+"\n")
    runfile.write('thisrun = open("ACTIVERUN.fl", "w")'+"\n")
    runfile.write('for line in therun:'+"\n")
    runfile.write("\t"+'newline = string.replace(line, "THE_BATCH_SIZE","'+str(batch_size)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_UNIQUE_PHENOTYPES","'+str(num_unique_phenotypes)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_LEARNER","1")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_SEED_TO_USE","'+str(which_seed_to_use)+'")'+"\n")
    runfile.write("\t"+'thisrun.write(newline)'+"\n")
    runfile.write('thisrun.close()'+"\n")
    runfile.write('therun.close()'+"\n")

    runfile.write('therun = open("THE_LINCS_RUN.fl", "r")'+"\n")
    runfile.write('thisrun = open("RANDOMRUN.fl", "w")'+"\n")
    runfile.write('for line in therun:'+"\n")
    runfile.write("\t"+'newline = string.replace(line, "THE_BATCH_SIZE","'+str(batch_size)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_UNIQUE_PHENOTYPES","'+str(num_unique_phenotypes)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_LEARNER","2")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_SEED_TO_USE","'+str(which_seed_to_use)+'")'+"\n")
    runfile.write("\t"+'thisrun.write(newline)'+"\n")
    runfile.write('thisrun.close()'+"\n")
    runfile.write('therun.close()'+"\n")

    runfile.write('os.symlink("'+results_location+'", "'+rundir+target_name+'/results")'+"\n")

    runfile.write('output = subprocess.call(["python", "process.py", "'+str(num_unique_phenotypes)+'"])'+"\n")
    runfile.write('output = subprocess.call(["forte", "-noX", "-f", "ACTIVERUN.fl"])'+"\n")
    runfile.write('output = subprocess.call(["forte", "-noX", "-f", "RANDOMRUN.fl"])'+"\n")

    runfile.close()
    return fname, target_name

def cleanup_jobs(tidx, jobacc):
    fname = 'RUN-cleanup-'+str(tidx)+'.sh'
    runfile = open(fname, 'w')
    runfile.write('#!/bin/sh'+"\n")
    runfile.write('#PBS -l walltime=48:20:00,mem=3000mb'+"\n")
    runfile.write('#PBS -m a'+"\n")
    runfile.write('#PBS -W umask=002'+"\n")
    for x, y in jobacc:
        runfile.write('rm '+rundir+x+"\n")
        runfile.write('mv '+rundir+x+'* '+MY_logs_location+"\n")
        runfile.write('rm -Rf '+rundir+y+"\n")
    runfile.close()
    return fname

    
random.seed(112358)
threadacc = []

for i in range(1,4):
    jobacc = []
    tname = 'LINCS-'+str(i)+'.thread'
    threadn = open(tname, 'w')
    threadacc.append(tname)
    for b in range(2,200):
        jobacc.append(make_case(rundir+'results_lincs', i, b, 50))
    final_cleanup = ""
    for x,y in jobacc:
        threadn.write(x+' 48:20:00 3000mb'+"\n")
        final_cleanup += ' '+x
    z = cleanup_jobs(i, jobacc)
    threadn.write(z+' 48:20:00 3000mb'+final_cleanup)
    threadn.close()

jobs = open('LINCS.jobs', 'w')
jobs.write('ADDTHREAD '+threadacc[0]+"\n")
for t in range(len(threadacc[1:])):
    jobs.write('ADDTHREAD '+threadacc[t+1]+' '+threadacc[t]+"\n")
jobs.close()
