import os
import string
import sys
import random

parent_dir = '/home/active/package/20120315.for_experiments/'
rundir = '/home/active/package/'
python_place = '/opt/python27/bin/python'
MY_results_location = '/home/active/package/results_stopping/'
MY_logs_location = '/home/active/package/logs_stopping/'

def make_case(results_location, session_name, which_seed_to_use, data_sample, batch_size, noise_level, num_drugs, num_proteins, num_unique_phenotypes, fraction_responsive, fraction_unique, which_method):

    target_name = '%s_sd%u_smpl%u_sz%u_noise%u_d%u_oi%u_p%u_resp%u_uniq%u_mthd%u' % (session_name, which_seed_to_use, data_sample, batch_size, noise_level, num_drugs, num_proteins, num_unique_phenotypes, fraction_responsive, fraction_unique, which_method)
    fname = 'RUN-'+target_name+'.py'
    runfile = open(fname, 'w')
    runfile.write('#!'+python_place+"\n")
    runfile.write('#PBS -l walltime=12:20:00,mem=3000mb'+"\n")
    runfile.write('#PBS -m a'+"\n")
    runfile.write('#PBS -W umask=002'+"\n")

    runfile.write('import os'+"\n")
    runfile.write('import string'+"\n")
    runfile.write('import subprocess'+"\n")
    runfile.write('os.mkdir("'+rundir+target_name+'")'+"\n")
    runfile.write('os.chdir("'+rundir+target_name+'")'+"\n")
    runfile.write('xs = os.listdir("'+parent_dir+'")'+"\n")
    runfile.write('for x in xs:'+"\n")
    runfile.write("\t"+'os.symlink("'+parent_dir+'"+x, "'+rundir+target_name+'"+"/"+x)'+"\n")
    runfile.write('therun = open("THE_CHOSEN_RUN.fl", "r")'+"\n")
    runfile.write('thisrun = open("ACTIVERUN.fl", "w")'+"\n")
    runfile.write('for line in therun:'+"\n")
    runfile.write("\t"+'newline = string.replace(line, "SESSION","active")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "DATA_SAMPLE","'+str(data_sample)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "THE_BATCH_SIZE","'+str(batch_size)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NOISE_LEVEL","'+str(noise_level)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_DRUGS","'+str(num_drugs)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_PROTEINS","'+str(num_proteins)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_UNIQUE_PHENOTYPES","'+str(num_unique_phenotypes)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "FRACTION_RESPONSIVE","'+str(fraction_responsive)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "FRACTION_UNIQUE","'+str(fraction_unique)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_METHOD","'+str(which_method)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_LEARNER","1")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "WHICH_SEED_TO_USE","'+str(which_seed_to_use)+'")'+"\n")
    runfile.write("\t"+'thisrun.write(newline)'+"\n")
    runfile.write('thisrun.close()'+"\n")
    runfile.write('therun.close()'+"\n")

#     runfile.write('therun = open("THE_CHOSEN_RUN.fl", "r")'+"\n")
#     runfile.write('thisrun = open("RANDOMRUN.fl", "w")'+"\n")
#     runfile.write('for line in therun:'+"\n")
#     runfile.write("\t"+'newline = string.replace(line, "SESSION","random")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "DATA_SAMPLE","'+str(data_sample)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "THE_BATCH_SIZE","'+str(batch_size)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "NOISE_LEVEL","'+str(noise_level)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "NUM_DRUGS","'+str(num_drugs)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "NUM_PROTEINS","'+str(num_proteins)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "NUM_UNIQUE_PHENOTYPES","'+str(num_unique_phenotypes)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "FRACTION_RESPONSIVE","'+str(fraction_responsive)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "FRACTION_UNIQUE","'+str(fraction_unique)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "WHICH_METHOD","'+str(which_method)+'")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "WHICH_LEARNER","2")'+"\n")
#     runfile.write("\t"+'newline = string.replace(newline, "WHICH_SEED_TO_USE","'+str(which_seed_to_use)+'")'+"\n")
#     runfile.write("\t"+'thisrun.write(newline)'+"\n")
#     runfile.write('thisrun.close()'+"\n")
#     runfile.write('therun.close()'+"\n")

    runfile.write('therun = open("generate_case.m", "r")'+"\n")
    runfile.write('thisrun = open("THISCASE.m", "w")'+"\n")
    runfile.write('for line in therun:'+"\n")
    runfile.write("\t"+'newline = string.replace(line, "DATA_SAMPLE","'+str(data_sample)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NOISE_RATE","'+str(noise_level)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_DRUGS","'+str(num_drugs)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_PROTEINS","'+str(num_proteins)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "NUM_UNIQUE_PHENOTYPES","'+str(num_unique_phenotypes)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "FRACTION_RESPONSIVE","'+str(fraction_responsive/100.0)+'")'+"\n")
    runfile.write("\t"+'newline = string.replace(newline, "FRACTION_UNIQUE","'+str(fraction_unique/100.0)+'")'+"\n")
    runfile.write("\t"+'thisrun.write(newline)'+"\n")
    runfile.write('thisrun.close()'+"\n")
    runfile.write('therun.close()'+"\n")

    runfile.write('os.symlink("'+results_location+'", "'+rundir+target_name+'/results")'+"\n")

    runfile.write('output = subprocess.call(["/usr/local/bin/matlab", "-nodisplay", "-r", "THISCASE"])'+"\n")
    runfile.write('output = subprocess.call(["forte", "-noX", "-f", "ACTIVERUN.fl"])'+"\n")
#    runfile.write('output = subprocess.call(["forte", "-noX", "-f", "RANDOMRUN.fl"])'+"\n")

    runfile.close()
    return fname, target_name

def cleanup_jobs(tidx, jobacc):
    fname = 'RUN-cleanup-'+tidx+'.sh'
    runfile = open(fname, 'w')
    runfile.write('#!/bin/sh'+"\n")
    runfile.write('#PBS -l walltime=12:20:00,mem=3000mb'+"\n")
    runfile.write('#PBS -m a'+"\n")
    runfile.write('#PBS -W umask=002'+"\n")
    for x, y in jobacc:
        runfile.write('rm '+rundir+x+"\n")
        runfile.write('mv '+rundir+x+'* '+MY_logs_location+"\n")
        runfile.write('rm -Rf '+rundir+y+"\n")
    runfile.close()
    return fname

    
random.seed(112358)

NUM_TRIALS = 500
NUM_JOBS_PER_TRIAL = 127
threadacc = []

tidx = 0
for responsive in range(5,100,5):
    for unique in range(5,100,5):
        covered = set([])
        jobacc = []
        for j in range(NUM_JOBS_PER_TRIAL):
            # propose = which seed to use, data sample, num phenotypes
            propose = random.randint(1,14), random.randint(1,14), random.randint(18,100)
            while propose in covered:
                propose = random.randint(1,14), random.randint(1,14), random.randint(18,100)
            covered.add(propose)
            jobacc.append(make_case(rundir+'results_stopping',
                                    "stopping",
                                    propose[0],
                                    propose[1],
                                    100,
                                    0,
                                    100,
                                    100,
                                    propose[2],
                                    responsive,
                                    unique,
                                    1))        
        tname = 'SMPL-STOPPING-r'+str(responsive)+'-u'+str(unique)+'.thread'
        threadn = open(tname, 'w')
        threadacc.append(tname)
        final_cleanup = ""
        for x,y in jobacc:
            threadn.write(x+' 12:20:00 3000mb'+"\n")
            final_cleanup += ' '+x
        z = cleanup_jobs(str(tidx), jobacc)
        tidx += 1
        threadn.write(z+' 12:20:00 3000mb'+final_cleanup)
        threadn.close()

jobs = open('SMPL-STOPPING.jobs', 'w')
for t in threadacc:
    jobs.write('ADDTHREAD '+t+"\n")
jobs.close()
