#!/usr/bin/perl

$parent_dir = '022011_prime';
@parent_files = <$parent_dir/*>;
$num_drugs = 100;
$num_proteins = 100;

open RUNJOBS, ">", "RUNJOBS";

#my $num_unique_phenotypes = 8;

sub make_case {

  my $num_unique_phenotypes = $_[0];
  my $which_seed = $_[1];
  my $data_sample = $_[2];
  my $responsive = $_[3];
  my $replicated = $_[4];
  my $which_method = $_[5];
  my $which_learner =  $_[6];

  my $place = sprintf 'method_seed%u_pheno%u_sample%u_resp%u_uniq%u_mthd%u_learn%u', $which_seed, $num_unique_phenotypes, $data_sample, $responsive, $replicated, $which_method, $which_learner;
  system("mkdir ${place}");
  system("mkdir ${place}/results");
  foreach $file (@parent_files) {
    @f = split(/\//, $file);
    $fname = $f[$#f];
    system("ln -s /home/awn/active/${parent_dir}/${fname} /home/awn/active/${place}/${fname}");
  }
  # THISRUN
  open THERUN, "<", "/home/awn/active/${place}/THE_TABLE1b_RUN.fl";
  open THISRUN, ">", "/home/awn/active/${place}/THISRUN.fl";
  while ($line = <THERUN>) {
    $line =~ s/WHICH_METHOD/$which_method/; 
    $line =~ s/WHICH_LEARNER/$which_learner/; 
    $line =~ s/DATA_SAMPLE/$data_sample/; 
    $line =~ s/WHICH_SEED_TO_USE/$which_seed/;
    $line =~ s/NUM_DRUGS/$num_drugs/;
    $line =~ s/NUM_PROTEINS/$num_proteins/;
    $line =~ s/NUM_UNIQUE_PHENOTYPES/$num_unique_phenotypes/;
    $line =~ s/FRACTION_RESPONSIVE/$responsive/;
    $line =~ s/FRACTION_REPLICATED/$replicated/;
    print THISRUN $line;
  }
  open GENCASE, "<", "/home/awn/active/${place}/generate_case.m";
  open THISCASE, ">", "/home/awn/active/${place}/THISCASE.m";
  while ($line = <GENCASE>) {
    $fr = $responsive/100;
    $fp = $replicated/100;
	  
    $line =~ s/DATA_SAMPLE/$data_sample/g;
    $line =~ s/NUM_DRUGS/$num_drugs/g;
    $line =~ s/NUM_PROTEINS/$num_proteins/g;
    $line =~ s/NUM_UNIQUE_PHENOTYPES/$num_unique_phenotypes/g;
    $line =~ s/FRACTION_RESPONSIVE/$fr/g;
    $line =~ s/FRACTION_REPLICATED/$fp/g;
    print THISCASE $line;
  }
	
  $rjob = "/home/awn/active/run__${place}.sh";
  open BFILE, "<", "blank__run.sh";
  open RUNFILE, ">", $rjob;
  while ($line = <BFILE>) {
    $line =~ s/WHICH/$place/g;
    print RUNFILE $line;
  }
  print RUNJOBS "JOB $rjob\n";
}

#&make_case(8,1,1,70,10);
#&make_case(8,1,1,90,25);
#&make_case(8,1,1,10,70);
#&make_case(8,1,1,25,90);

my $num_unique_phenotypes = 32;

while ( $num_unique_phenotypes <= 32 ) {

  for (my $which_seed = 1; $which_seed < 2; $which_seed++) {

    for (my $data_sample = 1; $data_sample < 4; $data_sample++) {

      for (my $responsive = 5; $responsive <= 100; $responsive+=5 ) {

	for (my $replicated = 5; $replicated <= 100; $replicated+=5 ) {

	  for (my $which_method = 1; $which_method < 3; $which_method++ ) {

	    for (my $which_learner = 1; $which_learner <= 2; $which_learner++ ) {
	      &make_case($num_unique_phenotypes,$which_seed,$data_sample,$responsive,$replicated, $which_method, $which_learner);
	    }
	  }
	 }
      }
    }
  }
  $num_unique_phenotypes = $num_unique_phenotypes*2;
}

# while ( $num_unique_phenotypes <= 8 ) {

#   for (my $which_seed = 1; $which_seed < 2; $which_seed++) {

#     for (my $data_sample = 1; $data_sample < 4; $data_sample++) {

#       for (my $responsive = 5; $responsive <= 100; $responsive+=5 ) {

# 	for (my $replicated = 5; $replicated <= 100; $replicated+=5 ) {

# #	  for (my $which_method = 1; $which_method < 2; $which_method++ ) {
# 	  $which_method = 3;
# 	    for (my $which_learner = 1; $which_learner <= 2; $which_learner++ ) {
# 	      &make_case($num_unique_phenotypes,$which_seed,$data_sample,$responsive,$replicated, $which_method, $which_learner);
# 	    }
# #	  }
# 	 }
#       }
#     }
#   }
#   $num_unique_phenotypes = $num_unique_phenotypes*2;
# }
