function figure6()
% this script generates Figure 6 from Naik et al
% these data were produced by simulations made by calling
% make_lincs_data.py from the parent directory
% and then calling 'dotdata.py' after the simulations completed

% Copyright (C) 2013,2014 Murphy Lab
% Lane Center for Computational Biology
% School of Computer Science
% Carnegie Mellon University
%
% This program is free software; you can redistribute it and/or modify
% it under the terms of the GNU General Public License as published
% by the Free Software Foundation; either version 2 of the License,
% or (at your option) any later version.
%
% This program is distributed in the hope that it will be useful, but
% WITHOUT ANY WARRANTY; without even the implied warranty of
% MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
% General Public License for more details.
%
% You should have received a copy of the GNU General Public License
% along with this program; if not, write to the Free Software
% Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA
% 02110-1301, USA.
%
% For additional information visit http://murphylab.web.cmu.edu or
% send email to murphy@cmu.edu

% these are produced by dotdata.py
overing = importdata('overing.csv');
params = importdata('params.csv');

scatter(params(:,2), params(:,1), 25, overing/280, 'fill')

set(gca,'YDir','normal')
hColorBar = colorbar;
axis square;
caxis([min(overing/280) max(overing/280)]);
hXLabel = xlabel('Responsive');
hYLabel = ylabel('Unique');
set( gca                       , ...
    'FontName'   , 'Helvetica' );
set([hXLabel, hYLabel, hColorBar], ...
    'FontName'   , 'Helvetica', ...
    'FontSize'   , 25);
set([hXLabel, hYLabel], ...
    'FontWeight' , 'bold'      );
set(gca, ...
  'Box'         , 'off'     , ...
  'TickDir'     , 'out'     , ...
  'TickLength'  , [.02 .02] , ...
  'XColor'      , [.0 .0 .0], ...
  'YColor'      , [.0 .0 .0], ...
  'YTick'       , .2:.1:1, ...
  'XTick'       , .2:.05:.4, ...
  'XMinorTick'  , 'off', ...
  'YMinorTick'  , 'off', ...
  'FontSize', 25, ...
  'LineWidth'   , 1         );
set(gcf, 'PaperPositionMode', 'auto');
cpos = get(hColorBar, 'Position');
cpos(1) = cpos(1) + 0.05;
cpos(3) = cpos(3)/2;
set(hColorBar,'Position',cpos);
print(gcf, '-dpng', 'figure6.png', '-r300');
